<?
/**
 * Given a uid, return a string representing the user's rank.
 * Thanks to Morbus (IRC) for this code
 */
function forum_user_rank($posts = NULL)
{
  global $user;
  if ($posts == NULL || !isset($user->uid)) { return NULL; }

  switch ($posts) {
    case $posts <= 10:  return 'n00b';
    case $posts <= 100:  return 'Killing Spree';
    case $posts <= 500:  return 'Rampage';
    case $posts <= 1000: return 'Dominating';
    case $posts <= 4000: return 'Unstoppable';
    case $posts <= 5000: return 'Godlike';
    case $posts <= 7000: return 'Wicked Sick';
    case $posts > 7000: return 'Oh Emm Gee';
  }
}

/** Returns the href link to a thread **/
function getActualThreadLink($tid)
{
  static $vals = array();
  if(!$vals[$tid])
  {
    $vals[$tid] = GetModuleName()."&c=showthread&ThreadID=".$tid;
  }
  return $vals[$tid];
}

/** Returns the entire <a> html code for the current thread 
**/
function getThreadLinkText($t)
{
  static $vals = array();
  if(!$vals[$t->ThreadID])
  {
    $vals[$t->ThreadID] = l(GetThreadTitle($t), getActualThreadLink($t->ThreadID));
  }
  return $vals[$t->ThreadID];
}

/** Returns the link to the last post of a thread
**/
function getThreadLinkTextLastPost($t, $objstr, $plus_initial=true)
{
  $numrows = $t->PostCount;
  $maxPage = GetMaxPageCount($numrows);

  $actual_link = getActualThreadLink($t->ThreadID)."&page=".$maxPage."#lastpost";
  if($plus_initial) $var = l(t($objstr), $actual_link, null, null, null, null, true);
  else $var = $actual_link;
  return $var;
}

function GetThreadTitle($t)
{
  return forum_filter('process', null, null, t($t->ThreadTitle));
}

/** Gets a user from their uid
**/
function GetUserFromID($ID)
{
  if(!is_numeric($ID))
    return false;

  static $vals = array();
  if(!$vals[$ID])
  {
    $query = db_query('SELECT * FROM {users} WHERE uid=%d', $ID);
    if ($Error = mysql_error())
    {
      echo "GetUserFromID: $Error";
      error_log("GetUserFromID: $q $Error");
    }
    $vals[$ID] =  mysql_fetch_object($query);
  }
  return $vals[$ID];
}

/** Returns the thread object that contains a specific post
**/
function GetThreadFromPost($PostID)
{
  $query = db_query("SELECT F_Threads.* FROM F_Threads, F_Posts WHERE F_Posts.PostID=%d AND F_Threads.ThreadID=F_Posts.ThreadID", $PostID);
  if ($Error = mysql_error())
    echo "$Error";
  return mysql_fetch_object($query);
}

/** Returns the forum object that contains the thread, that contains a specific post
**/
function GetForumFromPost($PostID)
{
  $query = db_query("SELECT F_Forums.* FROM F_Forums, F_Threads, F_Posts WHERE F_Posts.PostID=%d AND F_Threads.ThreadID=F_Posts.ThreadID AND F_Forums.ForumID=F_Threads.ForumID", $PostID);
  if ($Error = mysql_error())
    echo "$Error";
  return mysql_fetch_object($query);
}

/** Returns the forum object that contains a specific thread
**/
function GetForumFromThread($ThreadID)
{
  $query = db_query("SELECT F_Forums.* FROM F_Forums, F_Threads WHERE F_Threads.ThreadID=%d AND F_Forums.ForumID=F_Threads.ForumID", $PostID);
  if ($Error = mysql_error())
    echo "$Error";
  return mysql_fetch_object($query);
}

/**  Returns a thread object, that corresponds to a given thread id
**/
function GetThread($ThreadID)
{
  $query = db_query("SELECT F_Threads.* FROM F_Threads WHERE F_Threads.ThreadID=%d", $ThreadID);

  if ($Error = mysql_error())
    echo "$Error";
  return mysql_fetch_object($query);
}

/** Returns an array of threads that are contained withing a forum
*/
function GetThreadsFromForum($fid, $orderby = true, $pagelimit = true)
{
  static $storageArray = array();

  if(!$storageArray[$fid])
  {
    $Threads = Array();
    $q  = "SELECT F_Threads.* FROM F_Threads WHERE F_Threads.ForumID=%d ";
    $q .= $orderby ? "ORDER BY F_Threads.Sticky DESC, F_Threads.LastPost DESC " : "";
    $q .= $pagelimit ? "LIMIT ".GetPagesOffSet().", ".variable_get('forum_per_page', 25) : "";

    $query = db_query($q, $fid);

    $Threads = ToArray($Threads, $query);
    $storageArray[$fid] = $Threads;
  }
  return $storageArray[$fid];
}

/** Returns an array of all threads
*/
function GetThreads()
{
  $Threads = Array();
  $query = db_query("SELECT F_Threads.* FROM F_Threads");

  $Threads = ToArray($Threads, $query);
  return $Threads;
}

/** Returns all forums that are within a forum. (that a user has access to)
**/
function GetForums($fid, $arr = false, $forcerecount = false)
{
  Global $user;
  static $storageArray = array();
  if(!$storageArray[$fid])
  {
    $Forums = Array();

    if($fid == null)
      $limitsql = "SELECT * FROM F_Forums WHERE ParentForum is null OR ParentForum = 0 ";
    else
    {
      if($forcerecount)
      {
        $limitsql = "SELECT F_Forums.*, COUNT(DISTINCT(F_Threads.ThreadID)) AS ThreadCount, COUNT(DISTINCT(F_Posts.PostID)) AS PostCount FROM F_Forums LEFT JOIN F_Threads ON F_Threads.ForumID=F_Forums.ForumID LEFT JOIN F_Posts ON F_Posts.ThreadID=F_Threads.ThreadID WHERE F_Forums.ParentForum=%d";
      }
      else
      {
        $limitsql = "SELECT * FROM F_Forums WHERE F_Forums.ParentForum=%d";
      }
      if($arr && sizeof($arr) > 0)
      {
        foreach($arr AS $a)
        {
          // As I don't know how to pass an _array_ of values into db_query, I have to hard code the query with the variables needed to check. (rather than using drupal's %d syntax) - zoro
          $limitsql .= " OR F_Forums.ParentForum=".$a;
        }
        $limitsql .= " OR F_Forums.ForumID=".$fid;
      }
    }
    $limitsql .= GetAllowedForums();

    if($forcerecount)
      $limitsql .= " GROUP BY F_Forums.ForumID";

    $limitsql .= " ORDER BY weight, ForumName ASC";

    $query = db_query($limitsql, $fid);
    $Forums = ToArray($Forums, $query);
    $storageArray[$fid] = $Forums;
  }
  return $storageArray[$fid];
}

/** Returns a MYSQL string to be used to restrict a select statement to only those forums that a given user has access to
**/
function GetAllowedForums($fid = false)
{
   Global $user;
   static $basic;

   if(isset($basic)) return $basic;

   $Forums = Array();
   $allowed = array();
   $Forums = GetAllForums($fid);

   if(!user_access('administer '.GetModuleName()))
   {
     $temparr = Array();
     foreach($Forums as $f)
       $temparr[] = $f->ForumID;
     $groups = GetSecurityGroups(1, $temparr);

     foreach($groups AS $ga)
     {
       if($ga->HasAccess > 0)
       {
         if(user_access($ga->GroupName))
         {
           $allowed[] = $ga->HasAccess;
         }
       }
     }
   }
   $alltext = "";
   if(sizeof($allowed) > 0)
   {
     $alltext = " AND F_Forums.ForumID IN(";
     foreach($allowed AS $all)
       $alltext .= "'".$all."', ";
     $alltext = substr($alltext, 0, strlen($alltext)-2).")";
   }
   if(!$fid) $basic = $alltext;
   return $alltext;
}

/** Returns the number of (direct) children that a forum has. This is NOT recursive
**/
function ForumNumChildren($fid)
{
  $Forums = Array();
  $query = db_query("SELECT COUNT(ForumID) AS numchildren FROM F_Forums WHERE F_Forums.ParentForum=%d;", $fid);
  $Forums = ToArray($Forums, $query);
  return $Forums[0]->numchildren;
}

/** Returns an array of all forums as objects.
**/
function GetAllForums()
{
   Global $user;
   $Forums = Array();

   $query = db_query("SELECT STRAIGHT_JOIN DISTINCT (F_Forums.ForumID), F_Forums.* FROM F_Forums ORDER BY ForumName ASC");
   $Forums = ToArray($Forums, $query);
   return $Forums;
}

/** Returns a forum object that corresponds to a given forum fid
**/
function GetForum($fid, $list_only = false)
{
  static $forumList = array();

  if(!$forumList[$fid])
  {
    $limitsql = "SELECT * FROM F_Forums WHERE ForumID=%d";
    $query = db_query($limitsql, $fid);
    if ($Error = mysql_error())
      echo "$Error";
    $forumList[$fid] = mysql_fetch_object($query);
  }
  return $forumList[$fid];
}

/**  Returns a 2D array containing a forum object, and it's indentation int.
     Forums are listed in order of inheritance, weight, and then name.
     eg:
root
-- 1
---- 1a
-- 2
---- 2a
------ 2aa
**/
function GetForumsIndented($Forum = null, $indent = 0, $stop_recursion_on_forumid = false, $mod_only = false)
{
  static $found_vals = array();

  $big_array = array();
  if(is_int($Forum)) $Forum = GetForum($Forum, true);
  $ForumList = GetForums($Forum->ForumID);

  if($Forum != null)
  {
    if(!$mod_only || ($mod_only && user_access('moderate '.GetModuleName().'_'.$Forum->ForumID.'_'.GetModuleName())))
    {
      $big_array[] = array($Forum, $indent);
      $found_vals[] = $Forum->ForumID;
    }
  }
  if (sizeof($ForumList) >= 0)
  {
    $indent++;
    foreach($ForumList AS $fo)
    {
      if($fo->ForumID != $stop_recursion_on_forumid)
      {
        $temp_fo = GetForumsIndented($fo, $indent, $stop_recursion_on_forumid, $mod_only);

        if(ForumNumChildren($fo->ForumID) > 0)
        {
          foreach($temp_fo AS $t)
          {
            $big_array[] = $t;
          }
        }
        elseif(!$mod_only || ($mod_only && user_access('moderate '.GetModuleName().'_'.$fo->ForumID.'_'.GetModuleName())))
          $big_array[] = array($fo, $indent);
      }
    }
  }
  return $big_array;
}

/** Returns the list of security groups when fid is false (or null)
    otherwise, it returns the list of security restrictions currently set on a given forum
**/
function GetSecurityGroups($fid = false, $arr = false)
{
   static $generic;
   if(isset($generic)) return $generic;
   $groups = Array();

   if(!$fid)
     $query = db_query("SELECT * FROM F_Groups ORDER BY GroupID ASC");
   else
   {
     $limitsql = "SELECT g.*, ga.ForumID AS HasAccess FROM F_Groups g, F_Groups_Access ga WHERE (ga.ForumID=%d";
     if($arr && sizeof($arr) > 0)
     {
       foreach($arr AS $a)
         $limitsql .= " OR ga.ForumID=".$a;
     }
     $limitsql .= ") AND g.GroupID = ga.GroupID";
     $query = db_query($limitsql, $fid);
   }

   $groups = ToArray($groups, $query);
   if($arr) $generic = $groups;

/*
   if($fid)
     zoro("returning security groups for: $fid<br>");
   else
   {
     zoro("returning security groups for: ");
     foreach($arr AS $a)
       zoro("$a, ");
     zoro("<BR>");

     foreach($groups AS $a)
       zoro($a->HasAccess.", ");

     zoro("<BR>");
   }
*/
   return $groups;
}

/** Returns the security group that corresponds to a given groupid
**/
function GetSecurityGroup($GroupID)
{
   $query = db_query("SELECT * FROM F_Groups WHERE GroupID=%d", $GroupID);
   return mysql_fetch_object($query);
}

/** Adds a new security group.
    Param: $GroupName - the name of the group to add
    Param: $GroupShortName - the shortname of the group to add
**/
function AddSecurityGroup($GroupName, $GroupShortName)
{
   $query = db_query("INSERT INTO F_Groups (GroupName, GroupShortName) VALUES ('%s', '%s')", $GroupName, $GroupShortName);
   if ($Error = mysql_error())
     return "$Error";
}

/** Edits an existing security group.
    Param: $GroupID - the id of the group to modify
    Param: $GroupName - the name of the group to modify
    Param: $GroupShortName - the shortname of the group to modify
**/
function EditSecurityGroup($GroupID, $GroupName, $GroupShortName)
{
   $query = db_query("UPDATE F_Groups SET GroupName='%s', GroupShortName='%s' WHERE GroupID=%d", $GroupName, $GroupShortName, $GroupID);
   if ($Error = mysql_error())
     return "$Error";
}

/** Deletes a thread, and all posts contained therein
**/
function DeleteSecurityGroup($GroupID)
{
  $query = db_query("DELETE FROM F_Groups WHERE GroupID=%d", $GroupID);
  if ($Error = mysql_error())
    return "$q - $Error";

  $query = db_query("DELETE FROM F_Groups_Access WHERE GroupID=%d", $GroupID);
  if ($Error = mysql_error())
    return "$q - $Error";
}

/** Returns the number of posts by a user
**/
function GetUserPostPageCount($uid)
{
   return GetPageCount("SELECT COUNT(PostID) AS numrows FROM F_Posts, users WHERE users.uid=%d AND F_Posts.Poster = users.uid", $uid);
}

/** Returns the number of threads by a user
**/
function GetUserThreadPageCount($uid)
{
   return GetPageCount("SELECT COUNT(ThreadID) AS numrows FROM F_Threads, users WHERE users.uid=%d AND F_Threads.Creator = users.uid", $uid);
}

/** Returns the number of rows in a query
**/
function GetPageCount($str, $id)
{
  $query = db_query($str, $id);
  if($query == null)
  {
    return 1;
  }
  else
    return GetRowCount($query);
}

/** Returns the last post time for a user
**/
function GetLastPostTimeForUser($uid)
{
   $query = db_query("SELECT F_Posts.Posted FROM users, F_Posts WHERE F_Posts.Poster=%d ORDER BY F_Posts.PostID DESC LIMIT 1", $uid);
   $obj = mysql_fetch_object($query);
   return $obj->Posted;
}

/**
**/
function GetLastForumPostTest($fid)
{
  return mysql_fetch_object(db_query("SELECT users.uid, users.name, F_Threads.ThreadID, MAX(LastPost) AS LastPost FROM F_Threads, F_Forums, users WHERE F_Forums.ForumID=%d AND F_Forums.ForumID=F_Threads.ForumID AND users.uid=F_Threads.LastPoster GROUP BY F_Threads.ThreadID ORDER BY LastPost DESC LIMIT 1", $fid));
}

/** Gets the last post in a forum
**/
function GetLastForumPost($Forum)
{
  $ForumList = GetForums($Forum->ForumID);
  $obj = GetLastForumPostTest($Forum->ForumID);

  $latestpost = $obj->LastPost;
  $forumToReturn = $obj;

  if (sizeof($ForumList) != 0)
  {
    foreach($ForumList AS $fo)
    {
      $PostThingObject = GetLastForumPostTest($fo->ForumID);
      $PostThing = $PostThingObject->LastPost;
      if ($PostThing > $latestpost)
      {
        $latestpost = $PostThing;
        $forumToReturn = $PostThingObject;
      }
    }
  }
  return $forumToReturn;
}

/** Returns the number of rows in a query
**/
function GetRowCount($var)
{
  $rows = 0;
  if ($row = mysql_fetch_array($var, MYSQL_ASSOC))
    $rows = $row['numrows'];
  return $rows;  
}

/** Returns how many pages we have when using paging
**/
function GetMaxPageCount($numrows)
{
  return ceil($numrows/variable_get('forum_per_page', 25));
}

/** Returns a string containing page numbers for the current $page and $maxPage
**/
function GetPageNumbers($fid = null, $numrows)
{
  $var = ThisPage();
  $page = Page();
  if(strstr($var, "&page=".$page))
  {
    ThisPage(null, true);  //reset
    ThisPage(substr($var, 0, strpos($var, "&page=".$page)));
  }

  $self = ThisPage();
  if ($fid != null)
    $self .= "&fid=$fid";

// print 'previous' link only if we're not on page one
  if ($page > 1)
  {
    $pagetext = $page - 1;
    $prev = " ".l(t('&lt;'), $self."&page=".$pagetext, null, null, null, null, true);
    $first = " ".l(t('<strong>&laquo;</strong>'), $self."&page=1", null, null, null, null, true);
  }
  else
  {
    $prev  = ' &lt; ';       // we're on page one, don't enable 'previous' link
    $first = ' <strong>&laquo;</strong> '; // nor 'first page' link
  }

// print 'next' link only if we're not on the last page
  $maxPage = GetMaxPageCount($numrows);
  if ($page < $maxPage)
  {
    $pagetext = $page + 1;
    $next = " ".l(t('&gt;'), $self."&page=".$pagetext, null, null, null, null, true);
    $last = " ".l(t('<strong>&raquo;</strong>'), $self."&page=".$maxPage, null, null, null, null, true);
  }
  else
  {
    $next = ' &gt; ';      // we're on the last page, don't enable 'next' link
    $last = ' <strong>&raquo;</strong> '; // nor 'last page' link
  }

/*
  $nav  = $first.$prev;
  for($pages = 1; $pages <= $maxPage; $pages++)
  {
    if ($pages == $pageNum) // (SB) pagenum is undefined - dunno what to do with it
      $nav .= " $pages "; // no need to create a link to current page
    else
      $nav .= " <a href=\"$self&page=$pages\">$pages</a> ";
  }
  $nav .= $next.$last;
echo $nav;
*/

  $table = "Page: ";
  $table .= $first . $prev . " <strong>$page</strong> of <strong>$maxPage</strong>" . $next . $last;
  return $table;
}

/** Creates an array of mysql objects
**/
function ToArray($array, $val)
{
  if (mysql_num_rows($val) > 0)
  {
    while ( $Result = mysql_fetch_object($val) )
    {
      $array[] = $Result;
    } # Loop until we have them all
  }
  return $array;
}

/** Returns an array of the last posts made on the forum module. This _IS_ secured using GetAllowedForums()
**/
function GetLastPosts($num_posts = 10,$fid=false)
{
   global $user;

  $Threads = Array();
  $limitsql = "SELECT DISTINCT (F_Forums.ForumID), F_Threads.*, F_Forums.ForumName FROM F_Forums, F_Threads, F_Posts WHERE";

  if($fid)
    $limitsql .= " F_Forums.ForumID=%d AND ";

  $limitsql .= " F_Posts.ThreadID=F_Threads.ThreadID AND F_Forums.ForumID=F_Threads.ForumID".GetAllowedForums();
  $limitsql .= " ORDER BY LastPost DESC LIMIT ".$num_posts;
  if($fid)
    $query = db_query($limitsql, $fid);
  else
    $query = db_query($limitsql);
  echo mysql_error();

  $Threads = ToArray($Threads, $query);
  return $Threads;
}

/** Returns a post object that corresponds to a given PostID
**/
function GetPost($PostID)
{
//	  zoro("Getting post (".$PostID.")...");
  $query = db_query("SELECT STRAIGHT_JOIN * FROM F_Posts,users WHERE PostID=%d and F_Posts.Poster = users.uid", $PostID);
  if ($Error = mysql_error())
    echo "$Error";
//    zoro("done<br>");
  return mysql_fetch_object($query);
}

/** Returns an array of posts that are contained with a given thread
**/
function GetPosts($ThreadID, $paged = true)
{
  static $storageArray = array();

  if(!$storageArray[$ThreadID])
  {
    $Posts = Array();
    $q = "SELECT * FROM F_Posts LEFT JOIN users ON F_Posts.Poster = users.uid WHERE ThreadID=%d ORDER BY PostID ASC";
    if($paged)
      $q .= " LIMIT ".GetPagesOffSet().", ".variable_get('forum_per_page', 25);

    $query = db_query($q, $ThreadID);
    if ($Error = mysql_error())
      echo "$Error";
    $Posts = ToArray($Posts, $query);
    $storageArray[$ThreadID] = $Posts;
  }
  return $storageArray[$ThreadID];
}

/** Creates a thread
    Param: ThreadTitle - Title of the thread
    Param: ThreadText - Text(content) for the thread
    Param: fid - The forum to add this thread to
**/
function CreateThread($ThreadTitle, $ThreadText, $fid)
{
  Global $user;

  $query = db_query("INSERT INTO F_Threads (ThreadID, ThreadTitle, Creator, Created, LastPoster, LastPost, Locked, Sticky, ForumID) VALUES (NULL,'%s','%d',%s,'%d',%s, '%s', '%s', %d)", $ThreadTitle, $user->uid, 'NOW()', $user->uid, 'NOW()', '0', '0', $fid);
  if ($Error = mysql_error())
  {
    echo $Error;
    return false;
  }
  $query = db_query("SELECT ThreadID FROM F_Threads WHERE ThreadTitle='%s' AND ForumID=%d AND Creator=%d", $ThreadTitle, $fid, $user->uid);
  if ($Error = mysql_error())
  {
    echo "$Error";
    return false;
  }
  $result = mysql_fetch_object($query);
  if (!AddPost($result->ThreadID, $ThreadTitle, $ThreadText))
  {
    echo "<font color=\"red\">awh pooey :(</font><br />";
    return false;
  }
  UpdateCounts($fid, "forum", "thread", true);

  return $result->ThreadID;
}

/** Splits a thread from a given post onwards (inclusive)
    Param: edit - the array containing all relevant details needed for splitting
**/
function SplitThread($edit)
{
  $tid = $edit['tid'];
  $pid = $edit['pid'];
  $fid = $edit['fid'];
  $poster = $edit['poster'];
  $posted = $edit['posted'];
  $title = $edit['title']." [ Split ]";

  //Create the thread
  $query = db_query("INSERT INTO F_Threads (ThreadID, ThreadTitle, Creator, Created, LastPoster, LastPost, Locked, Sticky, ForumID) VALUES (NULL,'%s','%d','%s','%d','%s', '%s', '%s', '%d')", $title, $poster, $posted, $poster, $posted, '0', '0', $fid);
  if ($Error = mysql_error())
  {
    echo $Error;
    return false;
  }
  $query = db_query("SELECT ThreadID FROM F_Threads WHERE ThreadTitle='%s' AND ForumID='%d' AND Creator='%d' AND Created='%s'", $title, $fid, $poster, $posted);
  if ($Error = mysql_error())
  {
    echo "$Error";
    return false;
  }
  $result = mysql_fetch_object($query);

  $newThreadID = $result->ThreadID;

  $query = db_query("UPDATE F_Posts SET ThreadID='%d' WHERE ThreadID='%d' AND PostID >= '%d'", $newThreadID, $tid, $pid);
  if ($Error = mysql_error())
  {
    echo "$Error";
    return false;
  }

  UpdateCounts($tid, "thread");
  UpdateCounts($newThreadID, "thread");
  UpdateCounts($fid, "forum", "thread", true);

  if(UpdateLastPostDetails($newThreadID) && UpdateLastPostDetails($tid))
    return $tid;
  else
    return false;
}

function UpdateLastPostDetails($ThreadID)
{
  //Update the last-post of a thread
  $query = db_query("SELECT * FROM F_Posts WHERE ThreadID='%d' ORDER BY PostID DESC LIMIT 1", $ThreadID);
  if ($Error = mysql_error())
  {
    echo "$Error";
    return false;
  }
  $result = mysql_fetch_object($query);
  $query = db_query("UPDATE F_Threads SET LastPost='%s', LastPoster='%d' WHERE ThreadID='%d'", $result->Posted, $result->Poster, $ThreadID);
  if ($Error = mysql_error())
  {
    echo "$Error";
    return false;
  }
  return true;
}

/** Merges 2 threads
    Param: from - the thread to merge into the parent
	Param: to - the parent
**/
function MergeThread($from, $to)
{
  $threadFrom = GetThread($from);

  $query = db_query("UPDATE F_Posts SET ThreadID='%d' WHERE ThreadID='%d'", $to, $from);
  if ($Error = mysql_error())
  {
    echo "$Error";
    return false;
  }

  $query = db_query("DELETE FROM F_Threads WHERE ThreadID='%d'", $from);
  if ($Error = mysql_error())
  {
    echo "$Error";
    return false;
  }

  UpdateCounts($to, "thread");
  UpdateCounts($to, "thread", "view", $threadFrom->ViewCount);
  UpdateCounts($threadFrom->ForumID, "forum", "thread", -1);

  if(UpdateLastPostDetails($to))
    return $to;
  else
    return false;
}

/** Adds a new post
    Param: ThreadID - Thread to add the new post to
    Param: Title - Title of the post (optional)
    Param: Text - Content of the post
**/
function AddPost($ThreadID, $Title, $Text)
{
  Global $user;
  $Thread = GetThread($ThreadID);

  $query = db_query("INSERT INTO F_Posts (PostID, PostTitle, ThreadID, Poster, Posted, Content) VALUES (NULL,'%s','%d','%d',%s,'%s')", $Title, $ThreadID, $user->uid, 'NOW()', $Text);
  if ($Error = mysql_error())
  {
    form_set_error('UIE_FORUM_FORM', t($Error));
    return false;
  }
  $query = db_query("UPDATE F_Threads SET LastPoster='%d', LastPost=%s WHERE ThreadID=%d", $user->uid, 'NOW()', $ThreadID);
  if ($Error = mysql_error())
  {
    form_set_error('UIE_FORUM_FORM', t($Error));
    return false;
  }
  $query = db_query("SELECT MAX(PostID) AS PostID FROM F_Posts");
  if ($Error = mysql_error())
  {
    form_set_error('UIE_FORUM_FORM', t($Error));
    return false;
  }
  $result = mysql_fetch_object($query);

  UpdateCounts($Thread->ThreadID, "thread", "post", true);
  UpdateCounts($Thread->ForumID, "forum", "post", true);

  $query = db_query("REPLACE INTO F_Subs SET uid='%d', ThreadID='%d'", $user->uid, $ThreadID);
  if ($Error = mysql_error())
    echo "$Error";
  return $result->PostID;
}

/** Adds a new Forum
    Param: ForumName - Name of the forum to add
    Param: ForumDesc - Description of the forum to add
    Param: ForumParent - Parent forum of the forum to add
**/
function AddForum($ForumName,$ForumDesc,$ForumParent)
{
  $query = db_query("INSERT INTO F_Forums (ForumName, ParentForum, ForumDesc) VALUES ('%s', %d, '%s')", $ForumName, $ForumParent, $ForumDesc);
  if ($Error = mysql_error())
  {
    echo "$Error";
    return false;
  }

  $query = db_query("SELECT ForumID FROM F_Forums WHERE ForumName='%s' AND ParentForum=%d AND ForumDesc='%s'", $ForumName, $ForumParent, $ForumDesc);
  if ($Error = mysql_error())
  {
    return "Unable to add new forum";
  }

  $obj = mysql_fetch_object($query);
  if(variable_get('uieforum_auto_greet', 1))
    CreateThread("Welcome to ".$ForumName, "This is the first thread in your new forum. You can disable this auto-greeting post by disabling the relevant option on the configure page.", $obj->ForumID);
}

/** Deletes a post
**/
function DeletePost($PostID)
{
  $Post = GetPost($PostID);
  // Delete the post
  $query = db_query("DELETE FROM F_Posts WHERE PostID=%d", $PostID);
  if ($Error = mysql_error())
    return "$Error";

  // Check if the thread that the post came from is empty.
  $Posts = GetPosts($Post->ThreadID, false);
  $count = count($Posts);
  if ($count <= 0)
  {
    //Delete thread as no more posts exist
    $test = false;
    $test = DeleteThread($Post->ThreadID);
    if($test)
      return $test;
  }
  else
  {
    //Update thread as the post that was deleted was the last one. The "lastposter" and "lastpost" database entries need to be updated
    $Post = $Posts[$count-1];
    $Thread = GetThread($Post->ThreadID);
    $query = db_query("UPDATE F_Threads SET LastPoster='%d', LastPost='%s' WHERE ThreadID='%d'", $Post->Poster, $Post->Posted, $Post->ThreadID);

    UpdateCounts($Post->ThreadID, "thread", "post", -1);
    UpdateCounts($Thread->ForumID, "forum", "post", -1);
    if ($Error = mysql_error())
      return "$Error";
  }
}

/** Moves a post from one thread to another
**/
function MovePost($PostID, $ThreadID)
{
  $Post = GetPost($PostID);
  $query = db_query("UPDATE F_Posts SET ThreadID=%d WHERE PostID=%d", $ThreadID, $PostID);

  if ($Error = mysql_error())
    return "$Error";

  UpdateLastPostDetails($ThreadID);
  UpdateLastPostDetails($Post->ThreadID);

  UpdateCounts($Post->ThreadID, "thread", "post", -1);
  UpdateCounts($ThreadID, "thread", "post", true);
  return $ThreadID;
}

/** Deletes a thread, and all posts contained therein
**/
function DeleteThread($ThreadID)
{
  $Thread = GetThread($ThreadID);

  $query = db_query("DELETE FROM F_Posts WHERE ThreadID=%d", $ThreadID);
  if ($Error = mysql_error())
    return "$q - $Error";

  $query = db_query("DELETE FROM F_Subs WHERE ThreadID=%d", $ThreadID);
  if ($Error = mysql_error())
    return "$q - $Error";

  $query = db_query("DELETE FROM F_Threads WHERE ThreadID=%d", $ThreadID);
  if ($Error = mysql_error())
    return "$Error";

  UpdateCounts($Thread->ForumID, "forum", "thread", -1);
  UpdateCounts($Thread->ForumID, "forum", "post", ($Thread->PostCount)*-1);
}

/** Deletes a forum, and all forums, threads and posts contained therein
**/
function DeleteForum($ForumID)
{
  $ThisForum = GetForum($ForumID);
  $ThisChildren = GetForums($ForumID);
  $tester = false;

  if(sizeof($ThisChildren) > 0)
  {
    foreach($ThisChildren AS $child)
    {
      if($tester = DeleteForum($child->ForumID))
        return $tester;
    }
  }
  $ThisThreads = GetThreadsFromForum($ForumID);

  if(sizeof($ThisThreads) > 0)
  {
    foreach($ThisThreads AS $tt)
    {
      if($tester = DeleteThread($tt->ThreadID))
        return $tester;
    }
  }

  $query = db_query("DELETE FROM F_Groups_Access WHERE ForumID=%d", $ForumID);
  if ($Error = mysql_error())
    return "$Error";

  UpdateCounts($ThisForum->ParentForum, "forum");

  $query = db_query("DELETE FROM F_Forums WHERE ForumID=%d", $ForumID);
  if ($Error = mysql_error())
    return "$Error";

  if($tester)
    return $tester;
}

/** Edits a thread
    Param: ThreadID - ID of thread to edit
    Param: ThreadTitle - Titleof thread to edit
    Param: Locked - Is Thread locked?
    Param: Sticky - Is Thread stickied?
    Param: ForumID - ForumID of thread to edit
**/
function EditThread($ThreadID, $ThreadTitle, $Locked, $Sticky,$ForumID)
{
  $q="UPDATE F_Threads SET ThreadTitle='%s', Locked='%d',Sticky='%d' ";
  if($ForumID)
    $q .= ",ForumID='%d' ";
  $q .= "WHERE ThreadID='%d'";

  if($ForumID)
    $query = db_query($q, $ThreadTitle, $Locked, $Sticky, $ForumID, $ThreadID);
  else
    $query = db_query($q, $ThreadTitle, $Locked, $Sticky, $ThreadID);
  if ($Error = mysql_error())
    return "$Error";
}

/** Edits a forum
**/
function EditForum($fid,$ForumName,$ForumDesc,$ForumParent=false, $weight = 0, $accessgroups, $Locked)
{
  $query = db_query("SELECT ForumID FROM F_Forums WHERE ForumID=%d", $fid);
  if ($query == NULL)
    return "No such forum exists.";

  $q="UPDATE F_Forums SET ForumName='%s', ForumDesc='%s', weight='%d', Locked='%d' ";
  if($ForumParent)
    $q .= ",ParentForum='%d' ";
  $q .= "WHERE ForumID='%d'";

  if($ForumParent)
    $query = db_query($q, $ForumName, $ForumDesc, $weight, $Locked, $ForumParent, $fid);
  else
    $query = db_query($q, $ForumName, $ForumDesc, $weight, $Locked, $fid);
  if ($Error = mysql_error())
    return "$Error";

  $query = db_query("DELETE FROM F_Groups_Access WHERE ForumID=%d", $fid);
  if ($Error = mysql_error())
    return "$Error";

  foreach($accessgroups AS $ag)
  {
    if(is_array($ag)) continue;
    $query = db_query("REPLACE INTO F_Groups_Access SET ForumID='%d', GroupID='%d'", $fid, $ag);
    if ($Error = mysql_error())
      return "$Error";
  }
}

/** Edits a post
**/
function EditPost($PostID, $Title, $Text, $editor, $reason)
{
  Global $user;
  $query = db_query("UPDATE F_Posts SET PostTitle='%s', Content='%s', Edit=%s, Editor='%d', EditReason='%s' WHERE PostID=%d", $Title, $Text, 'NOW()', $editor, $reason, $PostID);
  if ($Error = mysql_error())
    return "$Error";
}

/** Returns the postcount of a user
**/
function PostCount($UserID)
{
  global $user;
  if (!isset($user->uid)) { return NULL; }

  $query = db_query("SELECT COUNT(PostID) from F_Posts WHERE Poster=%d", $UserID);
  return mysql_result($query, 0);
}

/** Displays a post on screen
**/
function DisplayPost($PostTime=0, $ThreadID, $PostID, $uid, $PostTitle, $PostText, $postcount = -1, $IsPreview = false, $fid, $editedpost = false, $sig = false, $show_avatar = true, $show_online_status = true, $show_post_count = true, $show_ranks = true, $show_regd = true, $show_sigs = true)
{
  Global $user;
  $guest_user = (!isset($uid) || $uid == 0 ? true : false);

  if($PostTime == 0)
    $PostTime = GetNow(0);

  $post_header = array(
    array('data' => '', 'colspan' => '1', 'class' => 'created', 'style' => 'font-weight: bold'),
    array('data' => '', 'colspan' => '1', 'class' => 'forum_pagenums')
  );
  $post_content = array(
    array('data' => '', 'colspan' => '1', 'class' => 'post_user_info', 'style' => 'font-weight: bold'),
    array('data' => '', 'colspan' => '1', 'class' => 'post_text')//, 'style' => 'vertical-align: top')
  );

  if ($IsPreview)
  {
    $post_header = array($post_header[0]);
    $post_content = array($post_content[1]);
    $post_header [0]['colspan'] = '2';
    $post_header [0]['data'] = forum_filter('process', null, null, $PostTitle, true);
    $post_content[0]['data'] .= forum_filter('process', null, null, $PostText, true);
    $post_content[0]['colspan'] = 2;
  }
  else
  {
    $post_footer = array(
      array('data' => '', 'colspan' => '1', 'class' => 'created', 'style' => 'font-weight: bold'),
      array('data' => '', 'colspan' => '1', 'class' => 'forum_pagenums')
    );

    $post_header [0]['data'] = $PostTime;
    $Poster = GetUserFromID($uid);


    $post_header [1]['data'] .= l($PostID, getActualThreadLink($ThreadID).'#'.$PostID, array('name' => $PostID));
//$_SERVER['HTTP_HOST'] . $_SERVER['PHP_SELF'];
//    $post_header [1]['data'] .= l($PostID, '#'.$PostID, array('name' => $PostID));

    if ($postcount == 0) $post_header[1]['data'] .= l(null, null, array('name' => 'lastpost'));

    if(user_access('administer '.GetModuleName()) || user_access('moderate '.GetModuleName().'_'.$fid.'_'.GetModuleName()))
    {
      $dropdownmenu = array(
        null => t($PostID),
        t(url('/admin/'.GetModuleName().'/edit/post/'.$PostID)) => t('Delete Post'),
        t(url('/admin/'.GetModuleName().'/edit/post/move/'.$PostID)) => t('Move Post'),
        t(url('/admin/'.GetModuleName().'/split/thread/'.$PostID)) => t('Split Thread'),
        t(url('/admin/'.GetModuleName().'/merge/thread/'.$ThreadID)) => t('Merge Thread')
/*
        t(url('/admin/'.GetModuleName().'/post/edit/'.$PostID)) => t('Delete Post'),
        t(url('/admin/'.GetModuleName().'/post/move/'.$PostID)) => t('Move Post'),
        t(url('/admin/'.GetModuleName().'/thread/split/'.$PostID)) => t('Split Thread'),
        t(url('/admin/'.GetModuleName().'/thread/merge/'.$ThreadID)) => t('Merge Thread')
*/
      );
      $admin_tools = form_select(null, "admin_edit_$PostID", t($PostID), $dropdownmenu, null, t('onChange="forum_admin_edit('.$PostID.')"'));
      $post_header [1]['data'] .= form($admin_tools, 'post', null, array('name' => 'unreal_'.$PostID));
    }





    $UserName = $Poster->name;
    $post_content[0]['data'] .= format_name(user_load(array('uid' => $uid)))."<br /><small>\n";
    if(!$guest_user)
    {
      if($show_ranks)
      {
	      if($Poster->uid == 1)
          $userrank = 'Super Admin';
	      else
          $userrank = forum_user_rank(UIE_Storage('postcount', $Poster->uid));
        if($userrank != null)
          $post_content[0]['data'] .= "$userrank<br /><br />\n";
      }
      if($show_avatar) $post_content[0]['data'] .= theme_user_picture($Poster);
      if($show_regd) $post_content[0]['data'] .= "<br />Joined: ".ParseDateOnly($Poster->created);

      if($show_post_count)
      {
        $userpostcount = UIE_Storage('postcount', $Poster->uid);
        if($userpostcount != null)
          $post_content[0]['data'] .= "<br/>Posts: $userpostcount<br /><br />";
      }
      if($show_online_status)
      {
        $is_active = UIE_Storage('useronline', $Poster->uid);
        $post_footer[0]['data'] .= _forum_user_online($Poster->name, $is_active);
      }
      if($user->uid || variable_get('forum_report_post_guest_allow', 0))
      {
        $alt = 'Report post to an Admin/Moderator';
        $file = variable_get('forum_icon_path', 'modules/'.GetModuleName().'/uie')."/forum-report.gif";
        $reportPostImage = theme('image', $file, $alt, $alt, '', false);

        if($reportPostImage)
        {
          $reportPost .= l($reportPostImage, GetModuleName()."/&c=reportpost&PostID=$PostID", null, null, null, null, true);
          $post_footer[0]['data'] .= $reportPost;
        }
      }
    }
    $post_content[0]['data'] .= "</small>\n";




    if (strlen($PostTitle) > 0)
      $post_content[1]['data'] .= "<strong>".forum_filter('process', null, null, $PostTitle, true)."</strong><br/>";
    $post_content[1]['data'] .= forum_filter('process', null, null, $PostText, true);
    $post_content[1]['data'] .= "<br/><br/>";
    if(!$guest_user && ($show_sigs && $sig))
      $post_content[1]['data'] .= "<div class=\"signature\">__________________<br/>".forum_filter('process', null, null, $sig)."</div>";



    $INTERACTION_TEXT = false;
    if (user_access('post new threads/posts'))
    {
      if(user_access('administer '.GetModuleName()) || user_access('moderate '.GetModuleName().'_'.$fid.'_'.GetModuleName()) || $user->uid == $uid)
        $INTERACTION_TEXT = l(t('Edit'), GetModuleName()."/&c=editpost&PostID=$PostID"). " - ";
      $INTERACTION_TEXT .= l(t('Quote'), GetModuleName()."/&c=newpost&ThreadID=$ThreadID&QuoteID=$PostID");
    }
    if($INTERACTION_TEXT) $post_footer[1]['data'] .= $INTERACTION_TEXT;

    if(is_array($editedpost) && $editedpost[0])
    {
      $tempuser = GetUserFromID($editedpost[0]);
      $DEFAULT_EDIT_REASON = trim(forum_filter('process', null, null, variable_get('forum_default_edit_reason', ''), true));
      $outputtext = "Last edited by ".$tempuser->name." (".ParseDate($editedpost[1]).")";

      $edited_reason = forum_filter('process', null, null, $editedpost[2], true);
      if(strlen(trim($edited_reason)) <= 0) $edited_reason = $DEFAULT_EDIT_REASON;
      if(strlen($edited_reason) > 0)
        $outputtext .= " Reason: ".$edited_reason;
      $post_content[1]['data'] .= "<hr><div class='uie_edit_text'><em>".$outputtext."</em></div>";
    }
  }

  return array($post_header, $post_content, $post_footer);
}

/** Returns the current date/time
**/
function GetNow($days=0)
{
  $Now = time();
  $Time = $Now - (86400*$days); # 86400 = num seconds in a day.
  return gmdate("Y-m-d H:i:s",$Time);
}

/** Not used at the moment - returns a different date format for rss display
**/
function ParseDateRSS($d)
{
  return date("D, d M Y H:i", strtotime($d))." +0000";
}

/**Returns a formatted date/time
**/
function ParseDate($d, $format = "d M Y - H:i")
{
  return date($format, strtotime($d));
}

/** Returns a formatted date
**/
function ParseDateOnly($d)
{
  return date("d M Y", $d);
}

/** Checks to see if a user has posted too soon since their last post.
**/
function PostedTooSoon($timeout)
{
  Global $user;
  $time = time();

  $userslastpost = GetLastPostTimeForUser($user->uid);

  $ender = $time - strtotime($userslastpost);
  if($ender <= $timeout)
    return $ender;
  else
    return false;
}

/** Returns the list of subscriptions for a user
**/
function GetSubs($uid)
{
  $subs = Array();

  if(!$uid)
    return null;
  else
  {
    $arr = Array();
    $query = db_query("SELECT F_Threads.ThreadID, F_Subs.SubID FROM F_Subs, F_Threads WHERE F_Subs.uid=%d AND F_Threads.ThreadID=F_Subs.ThreadID ORDER BY F_Threads.LastPost DESC", $uid);
    $arr = ToArray($arr, $query);
    foreach($arr AS $a)
    {
      $va = GetThread($a->ThreadID);
      $va->SubID = $a->SubID;
      $subs[] = $va;
    }
  }
  return $subs;
}

/** Deletes an array of subscriptions
**/
function DeleteSubs($arr)
{
  $test = "DELETE FROM F_Subs WHERE SubID IN(";
  foreach($arr AS $a)
    $test .= "$a, ";
  $test = substr($test, 0, strlen($test)-2).");";
  $query = db_query($test);
//  echo $test;
}

/** Returns a smiley array
**/
function GetSmileyList()
{
  static $smilies_array = array();

  if(sizeof($smilies_array) == 0)
  {
    /** Array of smilies
      contents: text replace   ---   regex to use to replace   ---   what to replace text with
      eg: ':)', ':) regex', 'smile.gif'
    **/
    $smilies_array = array
    (
      array(':idea:', 	'/:(?i)idea:/' ,	_forum_icon(null, null, null, 'idea.gif', true)),
      array(':mad:', 	'/:(?i)mad:/'  ,	_forum_icon(null, null, null, 'mad.gif', true)),
      array(':huh:', 	'/:(?i)huh:/'  ,	_forum_icon(null, null, null, 'confused.gif', true)),
      array(':lol:', 	'/:(?i)lol:/'  ,	_forum_icon(null, null, null, 'lol.gif', true)),
      array(':))'  , 	'/:-?\)\)/'    ,	_forum_icon(null, null, null, 'lol.gif', true)),
      array(':)'   , 	'/:-?\)/'      ,	_forum_icon(null, null, null, 'smile.gif', true)),
      array(':D'   , 	'/:-?[dD]/'    ,	_forum_icon(null, null, null, 'biggrin.gif', true)),
      array(':p'   , 	'/:-?[pP]/'    ,	_forum_icon(null, null, null, 'tongue.gif', true)),
      array(':('   , 	'/:-?\(/'      ,	_forum_icon(null, null, null, 'sad.gif', true)),
      array(':cool:',	'/:(?i)cool:/' ,	_forum_icon(null, null, null, 'cool.gif', true)),
      array(':crazy:',	'/:(?i)crazy:/',	_forum_icon(null, null, null, 'crazy.gif', true)),
      array(':fight:',	'/:(?i)fight:/',	_forum_icon(null, null, null, 'fight.gif', true)),
      array(':lurking:',	'/:(?i)lurking:/',	_forum_icon(null, null, null, 'lurking.gif', true)),
      array(':rolleyes:',	'/:(?i)rolleyes:/',	_forum_icon(null, null, null, 'rolleyes.gif', true)),
      array(':shock:',	'/:(?i)shock:/',	_forum_icon(null, null, null, 'shockcombo.gif', true)),
      array(':shoot:',	'/:(?i)shoot:/',	_forum_icon(null, null, null, 'shooting.gif', true)),
      array(':sleeping:',	'/:(?i)sleeping:/',	_forum_icon(null, null, null, 'sleeping.gif', true)),
      array(':|',    	'/:-?\|/'      ,	_forum_icon(null, null, null, 'stern.gif', true)),
      array(';)',    	'/;-?\)/'      ,	_forum_icon(null, null, null, 'wink.gif', true))
    );
  }
  return $smilies_array;
}

/** Order to display smilies in **/
function GetSmileySamples()
{
  static $SmilieSamples = array();

  if(sizeof($SmilieSamples) == 0)
  {
    $SmilieSamples = array
    ( 0 => array ( 6, 1, 13, 11),
      1 => array ( 7, 2, 10, 14),
      2 => array ( 5, 3, 17, 12),
      3 => array ( 9, 8, 16, 15),
      4 => array (18)
    );
  }
  return $SmilieSamples;
}

/** Returns a formatting icon array
**/
function GetFormattingIcons()
{
  $uie_rows = array();
  $uie_rows[] = array(
    array('data' => '<a href=javascript:Process(\'bold\') title=\'Insert bold text\'>'._forum_icon(null, null, null, 'bold.gif', null, true).'</a>'),
    array('data' => '<a href=javascript:Process(\'italic\') title=\'Insert italic text\'>'._forum_icon(null, null, null, 'italic.gif', null, true).'</a>'),
    array('data' => '<a href=javascript:Process(\'underline\') title=\'Insert underlined text\'>'._forum_icon(null, null, null, 'underline.gif', null, true).'</a>'),
    array('data' => '<a href=javascript:Process(\'url\') title=\'Insert a url\'>'._forum_icon(null, null, null, 'url.gif', null, true).'</a>'),
    array('data' => '<a href=javascript:Process(\'image\') title=\'Insert an inline image\'>'._forum_icon(null, null, null, 'image.gif', null, true).'</a>'),
    array('data' => '<a href=javascript:Process(\'quote\') title=\'Insert quoted text\'>'._forum_icon(null, null, null, 'quote.gif', null, true).'</a>'),
    array('data' => '<a href=javascript:Process(\'code\') title=\'Insert pre-formatted code\'>'._forum_icon(null, null, null, 'code.gif', null, true).'</a>'),
    array('data' => '<a href=javascript:Process(\'rant\') title=\'Give out sh*t about something\'>'._forum_icon(null, null, null, 'rant.gif', null, true).'</a>'),
    array('data' => '<a href=javascript:Process(\'left\') title=\'Align paragraph to left\'>'._forum_icon(null, null, null, 'align_left.jpg', null, true).'</a>'),
    array('data' => '<a href=javascript:Process(\'center\') title=\'Align paragraph to center\'>'._forum_icon(null, null, null, 'align_center.gif', null, true).'</a>'),
    array('data' => '<a href=javascript:Process(\'right\') title=\'Align paragraph to right\'>'._forum_icon(null, null, null, 'align_right.jpg', null, true).'</a>')
  );
  return $uie_rows;
}

function GetPagesOffSet()
{
  static $pagesoffset = 0;

  if(is_numeric($pagesoffset) && $pagesoffset <= 0)
    $pagesoffset = (Page() - 1) * variable_get('forum_per_page', 25);
  return $pagesoffset;
}

function GetForumListHeader()
{
  static $forum_forum_list_header = array();

  if(sizeof($forum_forum_list_header) == 0)
  {
    $forum_forum_list_header = array(
      array('data' => '&nbsp;', 'class' => 'created', 'style' => 'width: 3%'),
      array('data' => '<strong>Forum</strong>', 'class' => 'created'),
      array('data' => '<strong>Topics</strong>', 'class' => 'created', 'style' => 'width: 3%'),
      array('data' => '<strong>Posts</strong>', 'class' => 'created', 'style' => 'width: 3%'),
      array('data' => '<strong>Last Post</strong>', 'class' => 'created', 'style' => 'width: 20%')
    );
  }
  return $forum_forum_list_header;
}

function GetForumTopicListHeader()
{
  static $forum_topic_list_header = array();

  if(sizeof($forum_topic_list_header) == 0)
  {
    $forum_topic_list_header = array(
      array('data' => '&nbsp;', 'class' => 'created', 'style' => 'width: 3%'),
      array('data' => '<strong>Thread</strong>', 'class' => 'created'),
      array('data' => '<strong>Replies</strong>', 'class' => 'created', 'style' => 'width: 3%'),
      array('data' => '<strong>Views</strong>', 'class' => 'created', 'style' => 'width: 3%'),
      array('data' => '<strong>Last Post</strong>', 'class' => 'created', 'style' => 'width: 20%')
    );
  }
  return $forum_topic_list_header;
}

/** Checks to see of a post is being edited
**/
function IsEditPost()
{
  static $is_edit = false;

  if(!$is_edit)
    $is_edit = isset($edit['UIE_FORUM_EDIT_POST']) ? true : false;
  return $is_edit;
}


/** Used for links on page numbers
**/
function ThisPage($var = "", $reset = false)
{
  static $THIS_PAGE = "";

  if($reset || strlen(trim($THIS_PAGE)) == 0)
  {
    $THIS_PAGE = GetModuleName()."/";
    return;
  }
  if(strlen(trim($var)) > 0)
    $THIS_PAGE .= $var;
  return $THIS_PAGE;
}

function Page($p = false)
{
  static $page = 1;

  if($p && $p != $page)
    $page = $p;
  return $page;
}

function GetPostText($init = false)
{
  global $edit;
  static $PostText = false;

  if($init)
    $PostText = trim($init);
  elseif(isset($edit['PostText']))
    $PostText = trim($edit['PostText']);
  return $PostText;
}

function GetPostTitle($init = false)
{
  global $edit;
  static $PostTitle = false;

  if($init)
    $PostTitle = trim($init);
  elseif(isset($edit['PostTitle']))
    $PostTitle = trim($edit['PostTitle']);
  return $PostTitle;
}

function GetEditReason()
{
  global $edit;
  static $EditReason = false;

  if(isset($edit['EditReason']))
    $EditReason = trim($edit['EditReason']);
  return $EditReason;
}

function CurrentForum($fid = false, $force = false)
{
//	zoro("Getting current forum...");
  static $CurrentForum = false;

  if($force || (!$CurrentForum && ($fid)))
  {
    if(!$fid && $CurrentForum) $fid = $CurrentForum->ForumID;
    $CurrentForum = GetForum($fid);
  }
//  zoro("done<br>");
  return $CurrentForum;
}

function CurrentThread($id = false, $method='normal')
{
  static $CurrentThread = false;

  if($id)
  {
    switch($method)
    {
      case 'post': $CurrentThread = GetThreadFromPost($id); break;
      case 'normal': $CurrentThread = GetThread($id); break;
    }
  }
  return $CurrentThread;
}

function GetThreadPostCount($threadid)
{
  $query = mysql_fetch_object(db_query("SELECT COUNT(DISTINCT(F_Posts.PostID)) AS PostCount FROM F_Posts WHERE F_Posts.ThreadID=%d", $threadid));
  return $query->PostCount;
}

/**  Returns the number of threads/posts in a forum
**/
function GetForumInfo($Forum, $init = false, $forcereturn = false)
{
  static $fids, $finalcount, $storageArray;

  if(is_int($Forum))
  {
    $Forum = GetForum($Forum);
  }
  if(!$storageArray[$Forum->ForumID])
  {
    if($init)
    {
      $fids = array();
      $finalcount = array('ThreadCount' => 0, 'PostCount' => 0);
    }
    if($forcereturn)
      return $finalcount[$forcereturn];

    $ForumList = GetForums($Forum->ForumID, null, true);

    $fids[] = $Forum->ForumID;
    if (sizeof($ForumList) > 0)
    {
      foreach($ForumList AS $fo)
        GetForumInfo($fo);
    }

    if($init)
    {
      $list = GetForums($Forum->ForumID, $fids, true);
//      zoro("finalizing thread+postcount for: ");
      foreach($list AS $fn)
      {
//	     zoro(" ".$fn->ForumName);
         $finalcount['ThreadCount'] += $fn->ThreadCount;
         $finalcount['PostCount'] += $fn->PostCount;
      }
//      zoro("<br>");
      $storageArray[$Forum->ForumID] = $finalcount;
    }
  }
  return $storageArray[$Forum->ForumID];
}

function UpdateAllCounts($type, $fid = false, $tid = false)
{
  if(user_access('administer '.GetModuleName()))
  {
    if($type == "forums")
    {
      $Forums = GetAllForums($fid);

      foreach($Forums as $f)
      {
        UpdateCounts($f->ForumID, "forum");
      }
    }
    elseif($type == "threads")
    {
      if($fid)
      {
        $Threads = GetThreadsFromForum($fid, false, false);
      }
      elseif($tid)
      {
        $Threads = array();
        $Threads[] = GetThread($tid);
      }
      else
      {
        $Threads = GetThreads();
      }

      foreach($Threads as $t)
      {
        UpdateCounts($t->ThreadID, "thread");
      }
    }
  }
}

function UpdateCounts($id, $type, $counttype, $increment = false)
{
  switch($type)
  {
    case 'forum':
      $f = GetForum($id);

      if($increment == 0)
      {
        $info = GetForumInfo($f, true);
        $q = "UPDATE F_Forums SET ThreadCount='%d', PostCount='%d' WHERE ForumID=%d";
        $query = db_query($q, $info['ThreadCount'], $info['PostCount'], $id);
      }
      elseif($counttype)
      {
        if($counttype == "thread")
        {
          $field = "ThreadCount";
          $info = $f->ThreadCount + $increment;
        }
        elseif($counttype == "post")
        {
          $field = "PostCount";
          $info = $f->PostCount + $increment;
        }
        $q = "UPDATE F_Forums SET ".$field."='%d' WHERE ForumID=%d";
        $query = db_query($q, $info, $id);
      }
      else
      {
        return false;
      }
      if($f->ParentForum)
      {
        UpdateCounts($f->ParentForum, $type, $counttype, $increment);
      }

    case 'thread':
      $t = GetThread($id);
      $field = "PostCount";

      if($increment == 0)
      {
        $info = GetThreadPostCount($id);
        if($info < 0)
        {
          $info = 0;
        }
      }
      elseif($counttype)
      {
        if($counttype == "post")
        {
          $info = $t->PostCount + $increment;
        }
        if($counttype == "view")
        {
          $field = "ViewCount";
          $info = $t->ViewCount + $increment;
        }
      }
      else
      {
        return false;
      }
      $q = "UPDATE F_Threads SET ".$field."='%d' WHERE ThreadID=%d";
      $query = db_query($q, $info, $id);

    default:
  }
  if ($Error = mysql_error())
  {
    echo $Error;
    return false;
  }
}


function UIE_Storage($source, $uid, $reset = false)
{
  static $postcount_list = array();
  static $useronline_list = array();
  if($reset)
  {
    $postcount_list = array();
    $useronline_list = array();
  }
  else
  {
    switch($source)
    {
      case 'postcount':
        if(!isset($postcount_list["'".$uid."'"]))
          $postcount_list["'".$uid."'"] = PostCount($uid);
	if($uid == 75) return $postcount_list["'".$uid."'"] - 549 - 999;
        return $postcount_list["'".$uid."'"];

      case 'useronline':
        if(!isset($useronline_list["'".$uid."'"]))
        {
          // Count users with activity in the past defined period.
          $time_period = variable_get('user_block_seconds_online', 2700);
          $calc = time() - $time_period;

          // Perform database queries to gather online user lists (used to see if the poster is currently online)
          $users = db_query('SELECT DISTINCT(uid), MAX(timestamp) AS max_timestamp FROM {sessions} WHERE timestamp >= %d AND uid = %d GROUP BY uid ORDER BY max_timestamp DESC', $calc, $uid);
          $total_users = db_num_rows($users);

          $is_active = false;
          if ($total_users == 1)
            $is_active = true;
          $useronline_list["'".$uid."'"] = $is_active;
        }
        return $useronline_list["'".$uid."'"];
    }
  }
}
